
#include "stm8s.h"

//chastota 5000 hz
//128 razmer sinusa
//48 tochek
uint8_t counta=0;
uint8_t countb=0;
uint8_t countc=0;

uint8_t countemp=0;

uint8_t chastota=0;
uint16_t chastotaread=0;
uint16_t chastotaread1=0;
uint16_t chastotaread2=0;

uint16_t period=0;
uint16_t temperature=0;

uint8_t pack;

uint8_t command1 = 0b01000000; //     
uint8_t command2 = 0b11000000; // "  "

uint8_t symbol_1 = 0x76;//_1
uint8_t symbol_2 = 0x79;//_2
uint8_t symbol_3 = 0x38;//_3
uint8_t symbol_4 = 0x73;//_4

char command3 = 0b10001111; //  ON/OFF 

const uint8_t sinuc[48]={64,72,81,88,96,103,109,115,119,123,126,127,128,127,126,123,119,115,109,103,96,88,81,72,64,56,47,40,32,25,19,13,9,5,2,1,0,1,2,5,9,13,19,25,32,40,47,56};//tablica sinusov

const uint8_t mull[101]= {2,2,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13,14,14,15,15,16,16,17,17,18,18,19,19,20,20,21,21,22,22,23,23,24,24,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25};//mnozhiteli vf

const uint8_t tempmass[16]={5,10,20,25,35,50,65,75,90,110,140,160,190,220,240,250};//tablica konvertacii temperaturi

const uint8_t disp[13]= {0b00111111, 0b00110000, 0b01011011, 0b01111001,0b01110100,0b01101101,0b01101111,0b00111000,0b01111111,0b01111101,0b01110110, 0b00000000,0b10001111 };//znakogenerator

void gpioinit(void);

void tim1initis (void);//nastroika taimera shimov

void tim2initis (void);//nastroika taimera prerivaniya - upravleniya chastotoy

void lsdout (uint8_t bf, uint8_t cf);//programma vivoda informacii na displey

void priod (uint8_t fr);//programma nastroiki perioda taimera2 - ustanovka chastoti

void TM1637_start(void);//upravlenie displeem

void TM1637_stop(void);//upravlenie displeem

void TM1637_writeByte(uint8_t pack);//upravlenie displeem

void temperatura (void);//programma vichisleniya temperaturi po tablice

void Delay (uint16_t nCount);

@far @interrupt void OVFTIM2(void)//obrabotchik prerivaniya timer2
{
	TIM2_ClearITPendingBit(TIM2_IT_UPDATE);
GPIO_WriteReverse(GPIOA,GPIO_PIN_1);

if (counta >=47)
{
counta=counta-47;
}
countb = counta+16;
if (countb >=48)
{
countb=countb-47;
}
countc = counta+32;
if (countc >=48)
{
countc=countc-47;
}
		TIM1_SetCompare1( sinuc[counta]*mull[chastota]);
    TIM1_SetCompare2( sinuc[countb]*mull[chastota]);
    TIM1_SetCompare3( sinuc[countc]*mull[chastota]);
counta++;
}

main()
{
CLK_HSIPrescalerConfig( CLK_PRESCALER_HSIDIV1);
gpioinit();
tim1initis ();//nastraivaem timer1 - shim
tim2initis ();//nastraivaem timer 2 - upravlenie chastotoy

while(1){
ADC1_Init( ADC1_CONVERSIONMODE_SINGLE, ADC1_CHANNEL_12, ADC1_PRESSEL_FCPU_D6, ADC1_EXTTRIG_TIM, DISABLE, ADC1_ALIGN_RIGHT, ADC1_SCHMITTTRIG_CHANNEL12, DISABLE);//nastraivaem adc1 dlya izmereniya temperaturi
//   .
ADC1_ClearFlag( ADC1_FLAG_EOC);
// .
ADC1_StartConversion();
//  .
while( !ADC1_GetFlagStatus( ADC1_FLAG_EOC));
//  .
temperature=ADC1_GetConversionValue();
temperature=temperature>>2;
while (temperature > 100)//esli peregrev vikluchaem motor i vkluchaem ventilyator
{
GPIO_WriteHigh(GPIOD,GPIO_PIN_3);	//vkluchaem ventilyator
TIM1_CtrlPWMOutputs( DISABLE);	
chastota = 0;
temperatura();
ADC1_ClearFlag( ADC1_FLAG_EOC);
// .
ADC1_StartConversion();
//  .
while( !ADC1_GetFlagStatus( ADC1_FLAG_EOC));
//  .
temperature=ADC1_GetConversionValue();
temperature=temperature>>2;
}
//TIM1_CtrlPWMOutputs(ENABLE);	
if (temperature>90)//esli nagrev igbt vkluchaem ventilyator
{
GPIO_WriteHigh(GPIOD,GPIO_PIN_3);	
}
if (temperature<80)//igbt ostil- vikluchaem ventilyator
{
GPIO_WriteLow(GPIOD,GPIO_PIN_3);	
}
if(chastotaread == 0)
{
temperatura();//vivod temperatiri na lcd
}

ADC1_Init( ADC1_CONVERSIONMODE_SINGLE, ADC1_CHANNEL_5, ADC1_PRESSEL_FCPU_D6, ADC1_EXTTRIG_TIM, DISABLE, ADC1_ALIGN_RIGHT, ADC1_SCHMITTTRIG_CHANNEL5, DISABLE);//nastroim adc 1 ismeryaem chastotu 
//   .
ADC1_ClearFlag( ADC1_FLAG_EOC);
// .
ADC1_StartConversion();
//  .
while( !ADC1_GetFlagStatus( ADC1_FLAG_EOC));
//  .
chastotaread1=ADC1_GetConversionValue();
if ((chastotaread1 > (chastotaread2 + 10)) | (chastotaread1 < (chastotaread2 - 10)))//usranyaem drebezg adc - 10 edinic
{
chastotaread2=chastotaread1;	//zapominaem prediduchee izmerenie dlya usraneniya drebezga
chastotaread=chastotaread1;	
chastotaread=chastotaread >> 3;
if (chastotaread <= 27)//0-27 chitaem nulem
{
	chastotaread = 0;
}
else
{
chastotaread 	= (chastotaread - 27);//max chastota 127 (10bit_adc>>3)max chastota 100 hz
}
}
if (chastotaread > chastota)
{
	chastota++;
}
if (chastotaread < chastota)
{
	chastota--;
}
if (chastota > 100)
{
chastota = 100;	
}
priod (chastota);

if(chastota == 0)//esli dvigatel vikluchen pokazivaem temperaturu
{
//TIM1_CtrlPWMOutputs(DISABLE);	
temperatura();
}
else
{
	lsdout(chastota, 10);//vivodim chastotu, 10 - znak H
}
Delay(0x1ffF);

GPIO_WriteHigh(GPIOA,GPIO_PIN_2);

if ((TIM1->BKR & TIM1_BKR_MOE)==0)
{
if((GPIO_ReadInputPin( GPIOD, GPIO_PIN_0))& (chastota))//esli srabotal TOKOVAYA ZASCHITA plavnii pusk
{	
chastota = 0;
priod (chastota);
		TIM1_SetCompare1( sinuc[counta]*mull[chastota]);
    TIM1_SetCompare2( sinuc[countb]*mull[chastota]);
    TIM1_SetCompare3( sinuc[countc]*mull[chastota]);
		TIM1_CtrlPWMOutputs(ENABLE);	
}
GPIO_WriteLow(GPIOA,GPIO_PIN_2);
}
}
}


void priod (uint8_t fr)
{
uint16_t period;

if (fr == 0)
{
TIM1_CtrlPWMOutputs( DISABLE);	
}
period = 83333/fr;	
  TIM2->ARRH = (uint8_t)(period >> 8);
  TIM2->ARRL = (uint8_t)(period);	
}

void TM1637_start(void){
 GPIO_WriteHigh(GPIOC,GPIO_PIN_5);
GPIO_WriteHigh(GPIOC,GPIO_PIN_6);
Delay(200);
GPIO_WriteLow(GPIOC,GPIO_PIN_5);
}

void TM1637_stop(void){
GPIO_WriteLow(GPIOC,GPIO_PIN_6);
Delay(200);
GPIO_WriteLow(GPIOC,GPIO_PIN_5);
Delay(200);
GPIO_WriteHigh(GPIOC,GPIO_PIN_6);
Delay(200);
GPIO_WriteHigh(GPIOC,GPIO_PIN_5);
}

void TM1637_writeByte(uint8_t pack){
		char i;
    for(i=0;i<8;i++)  
  {
GPIO_WriteLow(GPIOC,GPIO_PIN_6);
    if(pack & 0x01)
  { GPIO_WriteHigh(GPIOC,GPIO_PIN_5);}
    else {GPIO_WriteLow(GPIOC,GPIO_PIN_5);}
  Delay(3);
    pack = pack >> 1;
    GPIO_WriteHigh(GPIOC,GPIO_PIN_6);
  Delay(3);
  }
  GPIO_WriteLow(GPIOC,GPIO_PIN_6);
  Delay(5);
  GPIO_WriteLow(GPIOC,GPIO_PIN_5);
  while((GPIO_ReadInputPin( GPIOC, GPIO_PIN_5)));
  GPIO_WriteHigh(GPIOC,GPIO_PIN_5);
  GPIO_WriteHigh(GPIOC,GPIO_PIN_6);
  Delay(2);
  GPIO_WriteLow(GPIOC,GPIO_PIN_6);
}

void lsdout(uint8_t bf, uint8_t cf)
{
	uint8_t ed;
	uint8_t des;
	uint8_t sot;

	sot=bf/100;//vichislyaem sotni
	des=(bf%100)/10;//vichislyaem desyatki
	ed=bf%10;//vichislyaem edinici
	if (sot == 0){//gasim nenuzhnii nolik
	sot = 11;// p probel
	}	
	if ((des == 0)&(sot == 11)){//gasim nenuzhnii nolik
	des = 11;// p probel
	}	
TM1637_start();
pack = command1;                    //    
TM1637_writeByte(pack);
TM1637_stop();
TM1637_start();
pack = command2;                   //     
TM1637_writeByte(pack);
pack = disp[cf];                // 1
TM1637_writeByte(pack);
pack = disp[ed];                   // 2
TM1637_writeByte(pack);
pack = disp[des];                  // 3
TM1637_writeByte(pack);
pack = disp[sot];                   // 4
TM1637_writeByte(pack);
TM1637_stop();
TM1637_start();
pack = command3;                  //,   
TM1637_writeByte(pack);
TM1637_stop();
Delay(2000);
}

void tim1initis (void)
{
	TIM1_DeInit();
TIM1_TimeBaseInit( 0, TIM1_COUNTERMODE_UP, 3200, 0);
TIM1_BDTRConfig( TIM1_OSSISTATE_DISABLE, TIM1_LOCKLEVEL_OFF, 20, TIM1_BREAK_ENABLE, TIM1_BREAKPOLARITY_LOW, TIM1_AUTOMATICOUTPUT_DISABLE);
TIM1_OC1Init( TIM1_OCMODE_PWM1, TIM1_OUTPUTSTATE_ENABLE, TIM1_OUTPUTNSTATE_ENABLE, 0, TIM1_OCPOLARITY_HIGH, TIM1_OCNPOLARITY_HIGH, TIM1_OCIDLESTATE_SET, TIM1_OCNIDLESTATE_SET);
TIM1_OC2Init( TIM1_OCMODE_PWM1, TIM1_OUTPUTSTATE_ENABLE, TIM1_OUTPUTNSTATE_ENABLE, 0, TIM1_OCPOLARITY_HIGH, TIM1_OCNPOLARITY_HIGH, TIM1_OCIDLESTATE_SET, TIM1_OCNIDLESTATE_SET);
TIM1_OC3Init( TIM1_OCMODE_PWM1, TIM1_OUTPUTSTATE_ENABLE, TIM1_OUTPUTNSTATE_ENABLE, 0, TIM1_OCPOLARITY_HIGH, TIM1_OCNPOLARITY_HIGH, TIM1_OCIDLESTATE_SET, TIM1_OCNIDLESTATE_SET);
//TIM1_ClearFlag( TIM1_FLAG_UPDATE);
//TIM1_ITConfig( TIM1_IT_UPDATE , ENABLE);
TIM1_OC1PreloadConfig( ENABLE);
TIM1_OC2PreloadConfig( ENABLE);
TIM1_OC3PreloadConfig( ENABLE);
TIM1_ARRPreloadConfig( ENABLE);
TIM1_CtrlPWMOutputs( ENABLE);
TIM1_Cmd( ENABLE);	
}

void tim2initis (void)
{
TIM2_TimeBaseInit(TIM2_PRESCALER_4, 1666);	
TIM2_ARRPreloadConfig(ENABLE);
TIM2_Cmd( ENABLE);
TIM2_ITConfig( TIM2_IT_UPDATE , ENABLE);
enableInterrupts();
}

void gpioinit (void)
{
GPIO_Init( GPIOC, GPIO_PIN_1, GPIO_MODE_OUT_PP_LOW_FAST);
GPIO_Init( GPIOC, GPIO_PIN_2, GPIO_MODE_OUT_PP_LOW_FAST);
GPIO_Init( GPIOC, GPIO_PIN_3, GPIO_MODE_OUT_PP_LOW_FAST);

GPIO_Init( GPIOC, GPIO_PIN_5, GPIO_MODE_OUT_PP_LOW_FAST);//data
GPIO_Init( GPIOC, GPIO_PIN_6, GPIO_MODE_OUT_PP_LOW_FAST);//scl

GPIO_Init( GPIOB, GPIO_PIN_0, GPIO_MODE_OUT_PP_LOW_FAST);
GPIO_Init( GPIOB, GPIO_PIN_1, GPIO_MODE_OUT_PP_LOW_FAST);
GPIO_Init( GPIOB, GPIO_PIN_2, GPIO_MODE_OUT_PP_LOW_FAST);

GPIO_Init( GPIOA, GPIO_PIN_1, GPIO_MODE_OUT_PP_LOW_FAST);
GPIO_Init( GPIOA, GPIO_PIN_2, GPIO_MODE_OUT_PP_LOW_FAST);	

GPIO_Init( GPIOD, GPIO_PIN_0,  GPIO_MODE_IN_PU_NO_IT);	
GPIO_Init( GPIOD, GPIO_PIN_3, GPIO_MODE_OUT_PP_LOW_FAST);

GPIO_Init( GPIOF, GPIO_PIN_4, GPIO_MODE_IN_FL_NO_IT);//a12
GPIO_Init( GPIOB, GPIO_PIN_5, GPIO_MODE_IN_FL_NO_IT);//a5	
}

void Delay(uint16_t nCount)
{
  /* Decrement nCount value */
  while (nCount != 0)
  {
    nCount--;
  }
}

void temperatura(void)
{
uint8_t i;	
countemp = 0;

for(i=0; i<16 ;i++) 
{
if	(temperature<tempmass[i])
{
countemp = i;	
i = 17;
}
}
countemp = countemp*5;//v tablice temperaturi shag 5 gradusov
lsdout(countemp, 12);
}

#ifdef USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *   where the assert_param error has occurred.
  * @param file: pointer to the source file name
  * @param line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif